"
 COPYRIGHT (c) 2018 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.  This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.
"
"{ Package: 'stx:libbasic' }"

"{ NameSpace: Smalltalk }"

SequenceableCollection variableSubclass:#AbstractMultidimensionalArray
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Collections-MultiDimensional'
!

!AbstractMultidimensionalArray class methodsFor:'documentation'!

copyright
"
 COPYRIGHT (c) 2018 by eXept Software AG
              All Rights Reserved

 This software is furnished under a license and may be used
 only in accordance with the terms of that license and with the
 inclusion of the above copyright notice.  This software may not
 be provided or otherwise made available to, or used by, any
 other person.  No title to or ownership of the software is
 hereby transferred.

"
! !

!AbstractMultidimensionalArray class methodsFor:'queries'!

isAbstract
    "Return if this class is an abstract class.
     True is returned here for myself only; false for subclasses.
     Abstract subclasses must redefine this again."

    ^ self == AbstractMultidimensionalArray.
! !

!AbstractMultidimensionalArray methodsFor:'accessing'!

dimensions
    self subclassResponsibility
! !

!AbstractMultidimensionalArray methodsFor:'error handling'!

dimensionError
    self error:'number of dimensions vs. number of given indices'
! !

!AbstractMultidimensionalArray methodsFor:'queries'!

isSquare
    |dims|

    dims := self dimensions.
    ^ dims size == 2
    and:[(dims at:1) == (dims at:2)]
! !

!AbstractMultidimensionalArray class methodsFor:'documentation'!

version_CVS
    ^ '$Header$'
! !

